<?php
/**
 * YANA library
 *
 *
 * Software:        Yana Framework 3.0.2
 * Author:          Dipl. Inf. Thomas Meyer
 * Homepage:        http://www.yanaframework.net
 * Copyright:       (c) 2015  Thomas Meyer
 * License:         GNU GPL  http://www.gnu.org/licenses/
 *
 * This program: can be redistributed and/or modified under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see http://www.gnu.org/licenses/.
 *
 * You may use this software for free. In case you like it, or want to
 * use it for a commercial purpose, please consider making a donation.
 * http://yanaframework.net/donate.php
 *
 * This notice MAY NOT be removed.
 *
 *
 * @package  yana
 * @license  http://www.gnu.org/licenses/gpl.txt
 */

/**
 * Log
 *
 * This class represents log entries passed to the YANA framework.
 * Note that the difference between instances of this class and
 * classes that derive from the base class "Message" is how instances
 * are treated by the function Yana::report().
 * While instances of class "Log" are send to the system logs for a
 * later review by an administrator, instances of class "Message"
 * are directly put to the user's browser.
 *
 * So: Logs are for the administrator - while Messages are for the
 * user.
 *
 * Usually you will have both: a Message for the user and a Log for the
 * administrator.
 *
 * E.g. your software detects a halt due to the failure of an important database operation.
 * Then you might issue a Message saying "Service is temporarily not available" to the user,
 * plus a Log saying "SQL statement '${stmt}' failed. The error reads: ${errMessage}."
 * for review by the administrator.
 *
 * @access      public
 * @package     yana
 * @subpackage  error_reporting
 */
class Log extends Report
{
}
// Copyright © 2015  Thomas Meyer  http://www.yanaframework.net
?>
