<?php
/**
 * YANA library
 *
 * This file contains functions and classes which are marked "deprecated".
 *
 *
 * Software:        Yana Framework 3.0.2
 * Author:          Dipl. Inf. Thomas Meyer
 * Homepage:        http://www.yanaframework.net
 * Copyright:       (c) 2015  Thomas Meyer
 * License:         GNU GPL  http://www.gnu.org/licenses/
 *
 * This program: can be redistributed and/or modified under the
 * terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see http://www.gnu.org/licenses/.
 *
 * You may use this software for free. In case you like it, or want to
 * use it for a commercial purpose, please consider making a donation.
 * http://yanaframework.net/donate.php
 *
 * This notice MAY NOT be removed.
 *
 *
 * @package  yana
 * @license  http://www.gnu.org/licenses/gpl.txt
 * @ignore
 */

/**
 * recursively merge two arrays to one
 *
 * This function is pretty much the same as the php function "array_merge_recursive"
 * except for the way how duplicate keys are treated. Dupplicate keys get replaced
 * in this implementation rather than being appended.
 *
 * As of version 2.8.8 this function was replaced by {@link Hashtable::merge()}
 * and marked deprecated.
 *
 * @param       array  $A
 * @param       array  $B
 * @return      array
 * @deprecated  since 2.8.8
 * @see         Hashtable::merge()
 * @ignore
 */
function mergeArrays($A, $B)
{
    return Hashtable::merge($A, $B);
}

/**
 * Lowercase or uppercase all keys of an associative array
 *
 * This is a recursive implementation of the PHP function array_change_key_case().
 * It takes the same arguments: an array $input to work on and an optional
 * argument $case. The argument $case can be one of two constants: CASE_LOWER and
 * CASE_UPPER, where CASE_LOWER is the default.
 *
 * As of version 2.8.8 this function was replaced by {@link Hashtable::changeCase()}
 * and marked deprecated.
 *
 * @param       array     $input
 * @param       int|bool  $case  CASE_UPPER or CASE_LOWER
 * @return      array
 * @deprecated  since 2.8.8
 * @see         Hashtable::changeCase()
 * @ignore
 */
function changeCaseArray($input, $case = CASE_LOWER)
{
    return Hashtable::changeCase($input, $case);
}

/**#@+
 * This class has been renamed to FormCreator
 *
 * Note that the constants also have been renamed,
 * by replacing 'GUI' by 'FORM' to comply with the
 * new name of the class.
 *
 * If you got code that relies on this class, please update it soon.
 * This class is to be dropped by version 3 of the framework.
 *
 * @deprecated  since 2.9.4
 * @ignore
 */

if (!defined('GUI_OVERVIEW'))    define('GUI_OVERVIEW',    1);
if (!defined('GUI_SEPERATED'))   define('GUI_SEPERATED',   2);
if (!defined('GUI_DETAILS'))     define('GUI_DETAILS',     3);
if (!defined('GUI_EDIT'))        define('GUI_EDIT',        4);
if (!defined('GUI_NEW'))         define('GUI_NEW',         5);
if (!defined('GUI_SEARCH'))      define('GUI_SEARCH',      6);
if (!defined('GUI_ADV_SEARCH'))  define('GUI_ADV_SEARCH',  7);

/**
 * GUI- and form-generator
 *
 * This class is a GUI- and form-generator,
 * that produces HTML-code from database
 * structure files.
 *
 * @access      public
 * @package     yana
 * @subpackage  core
 */
class GuiCreator extends FormCreator
{

}
/**#@-*/

/**
 * «abstract» InputStream
 *
 * As of version 2.9.5 this class was renamed to
 * FileSystemResource and is deprecated.
 *
 * @abstract
 * @access      public
 * @package     yana
 * @subpackage  file_system
 * @deprecated  since 2.9.5
 * @ignore
 */
class InputStream extends FileSystemResource
{
}

/**
 * checked reading of file sources
 *
 * As of version 2.9.5 this class was renamed to
 * FileReadonly and is deprecated.
 *
 * @access      public
 * @package     yana
 * @subpackage  file_system
 * @deprecated  since 2.9.5
 * @ignore 
 */
class SecureInputStream extends FileReadonly
{
}

/**
 * checked reading and writing of file sources
 *
 * As of version 2.9.5 this class was renamed to
 * File and is deprecated.
 *
 * @access      public
 * @package     yana
 * @subpackage  file_system
 * @deprecated  since 2.9.5
 * @ignore
 */
class SecureFileStream extends File
{
}

/**
 * Manipulate a directory
 *
 * As of version 2.9.5 this class was renamed to
 * Dir and is deprecated.
 *
 * @access      public
 * @package     yana
 * @subpackage  file_system
 * @deprecated  since 2.9.5
 * @ignore
 */
class DirStream extends Dir
{
}

/**
 * «utility» class Layout
 *
 * This is a global namespace for layout specific functions.
 * These functions implement recursive replacement of tokens.
 * This functionality is used for registry-files (sml/config)
 * of the framework.
 *
 * As of version 2.9.5 this class was renamed to
 * SmartUtility and is deprecated.
 *
 * @static
 * @access      public
 * @package     yana
 * @subpackage  core
 * @deprecated  since 2.9.5
 * @ignore
 */
class Layout extends SmartUtility
{
}

/**
 * «utility» DisplayUtility
 *
 * This is a utility class. It encapsulates extensions to use with
 * the smarty temlate engine.
 *
 * {@internal
 *
 * Additional smarty functions and modifiers are documented elsewhere.
 * This file should be ignored in API-documentation.
 *
 * }}
 *
 * As of version 2.9.5 this class was renamed to
 * SmartUtility and is deprecated.
 *
 * @static
 * @access      public
 * @package     yana
 * @subpackage  core
 * @deprecated  since 2.9.5
 * @ignore
 */
class DisplayUtility extends SmartUtility
{
}

/**
 * database structure file
 *
 * This wrapper class represents the structure of a database
 *
 * @access      public
 * @package     yana
 * @subpackage  database
 * @deprecated  since 2.9.6
 * @ignore
 */
class StructureFile extends DbStructure
{
}
// Copyright © 2015  Thomas Meyer  http://www.yanaframework.net
?>
