<?php/**
 * Yana Plugin "[%$ID%]"
[%if $DESCRIPTION%] *
 * [%$DESCRIPTION%]
[%/if%] *
 * @author      [%$AUTHOR%]
[%if $VERSION%] * @version     [%$VERSION%]
[%/if%] * @package     plugins
 */

/**
 * «plugin» class "plugin_[%$ID%]"
 *
 * @access      public
 * @package     plugins
[%if $PACKAGE%] * @subpackage  [%$PACKAGE%]
[%/if%]
 */
class plugin_[%$ID%] extends Plugin
{

[%if $dbStructure%]
    /**
     * Connection to data source (API)
     *
     * Is created by a factory function and can be either a connection to "some" database or a text-file,
     * depending on user settings. The correct type will be determined automatically. Take a look at the
     * documentation of class 'DbStream' for details on this API. (all alternative classes implement
     * the same interface, regardless whether the source is a file or a databse)
     *
     * {@internal
     *
     * NOTE:
     * As of PHP 5 the notation "var $database" became deprecated, resulting in an E_STRICT_NOTICE.
     * So you may want to change this to "private $database" for PHP 5. Just be aware that doing so will
     * break backwards compatibility with PHP 4.
     *
     * }}
     *
     * @access  private
     * @var     object serializeableObject  Database-API with Query-Builder (also works with text-files)
     *
     * @ignore
     */
    var $database;
[%/if%]

    /**
     * Constructor
     *
     * @access  public
     * @name    plugin_[%$ID%]::__construct()
     * @param   string  $name  a name for this plugin
     */
    function __construct($name)
    {
        assert('is_string($name);');

        $this->name = $name;
[%if $dbStructure%]
        global $YANA;
        $this->database = $YANA->connect("[%$ID%]");
[%/if%]
    }

    /**
     * Default event handler
     *
     * returns bool(true) on success and bool(false) on error
     *
     * @access  public
     * @return  bool
     * @name    plugin_[%$ID%]::_default()
     * @param   string  $event  name of the called event in lower-case
     * @param   array   $ARGS   array of arguments passed to the function
     */
    function _default($event, $ARGS)
    {
        /* NOTE:
         * Fnction "assert()" is a helper for debugging your plugins.
         * It evaluates the given string as an PHP-expression and issues
         * an E_NOTICE to screen / log-file if it evaluates to bool(false).
         *
         * "Assertions" can be turned off if your application has reached
         * production stage by setting the appropriate debug-constant in
         * index.php
         */

        /* check input data */
        assert('is_string($event);');
        assert('is_array($ARGS);');
        settype($event, "string");
        settype($ARGS, "array");
        $event = strtolower($event);

        /* global variables */
        global $YANA;

        /* do something */

        /* NOTE: event handlers should always return a boolean value.
         * Return "true" on success or "false" on error.
         */
        return true;
    }

/* BEGIN custom Event-handlers */

    /* NOTE:
     * All member-functions stated here act as action handlers
     * (event handlers) and may be called directly in a browser
     * by typing index.php?action=function_name
     *
     * (you may exclude a single function from this behaviour by
     * starting it's name with an underscore '_')
     *
     * While it is not required by default, it is thus highly
     * recommended that you specify all functions within
     * the "INTERFACE"-section of your plugin.config.
     * Refer to the manual for details.
     *
     * For security reasons you may want to override this behaviour
     * to deny access by default if no "INTERFACE"-section AND
     * "INTERFACE.function_name.PERMISSION" entry is provided
     * by setting "DEFAULT.EVENT.PERMISSION" to "-1" in the
     * config/system.config file.
     * Note that this might break up some plugins!
     * As an alternative: setting the value to "1" will require
     * users to be at least registered and logged in to be able
     * to call "unprotected" functions.
     */

[%foreach key="NAME" item="CURRENT" from=$INTERFACE%]

    /**
     * [%$NAME%]
     *
     * returns bool(true) on success and bool(false) on error
     *
     * Type:        [%$CURRENT.TYPE%]
     * Permission:  [%$CURRENT.PERMISSION%]
     * Templates:   [%if $CURRENT.TEMPLATE%][%$CURRENT.TEMPLATE%] [%/if%][%$CURRENT.INSERT%]
     *
     * @access  public
     * @return  bool
     * @name    plugin_[%$ID%]::[%$NAME%]()
     * @param   array  $ARGS  array of params passed to the function
     */
    function [%$NAME%] ($ARGS)
    {
        /* check input data */
        assert('is_array($ARGS);');
        settype($ARGS, "array");

        /* global variables */
        global $YANA;

        /* do something */
        return true;
    }

[%/foreach%]

/* END custom Event-handlers */

/* BEGIN auto-generated Event-handlers */

[%foreach key="NAME" item="CURRENT" from=$AUTO_INTERFACE%]
[%assign var="NAME" value=$NAME|lower%]

    /**
     * [%$NAME%]
     *
     * returns bool(true) on success and bool(false) on error
     *
     * Type:        [%$CURRENT.TYPE%]
     * Permission:  [%$CURRENT.PERMISSION%]
     * Templates:   [%if $CURRENT.TEMPLATE%][%$CURRENT.TEMPLATE%] [%/if%][%$CURRENT.INSERT%]
     *
     * @access  public
     * @return  bool
     * @name    plugin_[%$ID%]::[%$NAME%]()
     * @param   array  $ARGS  array of params passed to the function
     */
    function [%$NAME%] ($ARGS)
    {
        /* check input data */
        assert('is_array($ARGS);');
        settype($ARGS, "array");

        /* global variables */
        global $YANA;

[%if $CURRENT.PRESET == "new" && $CURRENT.TYPE == "write"%]

        $newEntry = GuiCreator::getFormdata(FORM_NEW, $this->database->structure, '[%$CURRENT.TABLE%]');

        /* no data has been provided */
        if (empty($newEntry)) {
            $YANA->report(new Warning('INPUT_INVALID'));
            return false;
        }

        /* insert new entry into table */
        if (!$this->database->insert("[%$CURRENT.TABLE|lower%].*", $newEntry)) {
            $YANA->report(new Warning('INPUT_INVALID'));
            return false;
        } else {
            return $this->database->write();
        }
[%elseif $CURRENT.PRESET == "delete"%]
        /* check if user forgot to mark at least 1 row */
        if (empty($ARGS['selected_entries']) || !is_array($ARGS['selected_entries'])) {
            $YANA->report(new Warning('INPUT_INVALID'));
            return false;
        }
        /* remove entry from database */
        foreach ($ARGS['selected_entries'] as $id)
        {
            if (!$this->database->remove("[%$CURRENT.TABLE|lower%].${id}")) {
                /* entry does not exist */
                $YANA->report(new Warning('INPUT_INVALID'));
                return false;
            }
        } /* end for */
        /* commit changes */
        return $this->database->write();
[%elseif $CURRENT.PRESET == "edit" && $CURRENT.TYPE == "write"%]

        $updatedEntries = GuiCreator::getFormdata(FORM_EDIT, $this->database->structure, '[%$CURRENT.TABLE%]');

        /* no data has been provided */
        if (empty($updatedEntries)) {
            $YANA->report(new Warning('INPUT_INVALID'));
            return false;
        }

        foreach ($updatedEntries as $id => $entry)
        {
            $id = strtolower($id);

            /* update the row */
            if (!$this->database->update("[%$CURRENT.TABLE|lower%].${id}", $entry)) {

                /* error - unable to perform update - possibly readonly, or no such entry */
                $YANA->report(new Warning('INPUT_INVALID'));
                return false;

            }
        } /* end for */
        /* commit changes */
        return $this->database->write();
[%elseif $CURRENT.PRESET == "search"%]
        return true;
[%elseif $CURRENT.TEMPLATE === "MESSAGE" %]
        $YANA->report( new Message('200') );
        $YANA->exitTo([%if $CURRENT.TYPE == "config" %]'index'[%else%]''[%/if%]);
        return true;
[%else%]
        $where = array();
[%foreach from=$CURRENT.REFERENCE item='reference' %]
        if (isset($ARGS['target']) && isset($ARGS['target']['[%$reference.2|lower%]'])) {
            $where[] = array('[%$reference.1|lower%]', $ARGS['target']['[%$reference.2|lower%]'], '=');
            $_SESSION['[%$reference.0%]'][__FUNCTION__]['[%$reference.2|lower%]'] = $ARGS['target']['[%$reference.2|lower%]'];
        } else if (isset($_SESSION['[%$reference.0%]'][__FUNCTION__]['[%$reference.2|lower%]'])) {
            $where[] = array('[%$reference.1|lower%]', $_SESSION['[%$reference.0%]'][__FUNCTION__]['[%$reference.2|lower%]'], '=');
        }
[%/foreach%]
        $YANA->setVar("WHERE", $where);

        return true;
[%/if%]
    }
[%/foreach%]

/* END auto-generated Event-handlers */

/* BEGIN auto-generated functions */
[%if $dbStructure%]
[%foreach item="TABLE" from=$dbStructure->getTables()%]
[%if $dbStructure->getFiles($TABLE)%]
    /**
     * download action
     *
     * {@internal
     * Note that checks for security restrictions can't be created automatically.
     * If you need to restrict access to image or file resources in the database
     * beyond the scope of this simple implementation, you need to add appropriate
     * security tests to this code.
     * }}
     *
     * @access  private
     * @name    plugin_[%$ID%]::[%$NAME%]()
     * @param   array  $ARGS  array of params passed to the function
     *
     * @ignore
     */
    function [%$ID%]_[%$TABLE%]_download($ARGS)
    {
        if (($source = DbBlob::getFileId()) === false) {
            return false;
        } else {
            $dir = toRegExp($GLOBALS['YANA']->getVar('DBBLOB'));
            // downloading a file:
            if (preg_match('/^' . $dir . 'file\.\w+\.gz$/', $source)) {
    
                $dbBlob = new DbBlob($source);
                $dbBlob->read();
                header('Content-Disposition: attachment; filename=' . $dbBlob->getPath());
                header('Content-Length: ' . $dbBlob->getFilesize());
                header('Content-type: ' . $dbBlob->getMimeType());
                print $dbBlob->get();
        
            // downloading an image:
            } elseif (preg_match('/^' . $dir . '(image|thumb)\.\w+\.png$/', $source)) {
                $image = new Image($source);
                $image->outputToScreen();
            } else {
                print "Error: invalid resource.";
            }
            exit;
        }
    }
[%/if%]
[%/foreach%]
    /* NOTE:
     * By convention you can hide any member function from the plugin manager
     * by using an underscore '_' as the first character of the function's name.
     * This results in: any such function (event) can not be triggered directly
     * by the user through pointing the "action" parameter in the url to that
     * function name, like: index.php?action=function_name
     *
     * (Using underscores is a common PHP4 notation for "private")
     *
     * This also means, if for some reason you need to create a public event handler
     * whose name somehow has to begin with an underscore, you need to declare this
     * within the class' default event handler.
     */

    /**
     * remove tags from user form data
     *
     * @static
     * @access  private
     * @name    plugin_[%$ID%]::_untaintInput()
     * @param   array   $input  associative array containing user form data
     *
     * @ignore
     */
    function _untaintInput(&$input)
    {
        if (is_array($input)) {
            foreach ($input as $a => $b)
            {
                $input[$a] = untaintInput($b, "string", 0, YANA_ESCAPE_USERTEXT);
            }
        }
    }

[%/if%]
/* END auto-generated functions */

}
?>
